(***************************************************************************
*                                                                          *
* Automatically generated file, do not modify                              *
*                                                                          *
* Emmanuel Polonowski, March 2012, Coq v8.3                                *
*                                                                          *
***************************************************************************)

Require Import Arith Omega.


(* ********************************************************************** *)
(** * Syntax definition                                                   *)

Module STLCexp.

  Create HintDb STLCexp_database.


  (** ** General Tactics *)

  Hint Rewrite Plus.plus_0_r Minus.minus_diag : STLCexp_database.

  Ltac omega_tac :=
    omega || (absurd False; auto; omega).

  Ltac crush_tac :=
    autorewrite with STLCexp_database in *; auto with STLCexp_database; try omega_tac;
      try match goal with
            | [ H : False |- _ ] => inversion H
          end;
      try (f_equal; auto with STLCexp_database; try omega_tac; fail);
      try (do 2 f_equal; auto with STLCexp_database; try omega_tac; fail);
      try (do 3 f_equal; auto with STLCexp_database; try omega_tac; fail);
      try (do 4 f_equal; auto with STLCexp_database; try omega_tac; fail);
      try (do 5 f_equal; auto with STLCexp_database; try omega_tac; fail).

  Ltac ecrush_tac :=
    autorewrite with STLCexp_database in *; eauto with STLCexp_database; try omega_tac;
      try match goal with
            | [ H : False |- _ ] => inversion H
          end;
      try (f_equal; eauto with STLCexp_database; try omega_tac; fail);
      try (do 2 f_equal; eauto with STLCexp_database; try omega_tac; fail);
      try (do 3 f_equal; eauto with STLCexp_database; try omega_tac; fail);
      try (do 4 f_equal; eauto with STLCexp_database; try omega_tac; fail);
      try (do 5 f_equal; eauto with STLCexp_database; try omega_tac; fail).

  Ltac cfail :=
    simpl; crush_tac; fail.




  (** * Inductive syntax and function definitions *)


  (** *** De Bruijn primitive syntax *)

  Inductive binop : Type :=
  | plus 
  | mult 
  .

  Hint Constructors binop : STLCexp_database.

  Inductive term : Type :=
  | var (x : nat)
  | app (t1 : term) (t2 : term)
  | lam (t : term)
  | eterm (e : exp)

  with exp : Type :=
  | int (n : nat)
  | bop (op : binop) (e1 : exp) (e2 : exp)
  | texp (t : term)
  .

  Hint Constructors term exp : STLCexp_database.


  (** *** De Bruijn lifting function *)

  Fixpoint term_lift_in_term (_n : nat) (_m : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        if le_lt_dec _m x then var (x + _n) else var x
      | app t1 t2 =>
        app (term_lift_in_term _n _m t1) (term_lift_in_term _n _m t2)
      | lam t =>
        lam (term_lift_in_term _n (_m + 1) t)
      | eterm e =>
        eterm (term_lift_in_exp _n _m e)
    end

  with term_lift_in_exp (_n : nat) (_m : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | int n =>
        int n
      | bop op e1 e2 =>
        bop op (term_lift_in_exp _n _m e1) (term_lift_in_exp _n _m e2)
      | texp t =>
        texp (term_lift_in_term _n _m t)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma term_lift_in_term_var :
    forall (_n : nat) (_m : nat) (x : nat),
      term_lift_in_term _n _m (var x) =
        if le_lt_dec _m x then var (x + _n) else var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_var : STLCexp_database.

  Lemma term_lift_in_term_app :
    forall (_n : nat) (_m : nat) (t1 : term) (t2 : term),
      term_lift_in_term _n _m (app t1 t2) =
        app (term_lift_in_term _n _m t1) (term_lift_in_term _n _m t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_app : STLCexp_database.

  Lemma term_lift_in_term_lam :
    forall (_n : nat) (_m : nat) (t : term),
      term_lift_in_term _n _m (lam t) =
        lam (term_lift_in_term _n (_m + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_lam : STLCexp_database.

  Lemma term_lift_in_term_eterm :
    forall (_n : nat) (_m : nat) (e : exp),
      term_lift_in_term _n _m (eterm e) =
        eterm (term_lift_in_exp _n _m e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_eterm : STLCexp_database.

  (** Equations for De Bruijn lifting function *)

  Lemma term_lift_in_exp_int :
    forall (_n : nat) (_m : nat) (n : nat),
      term_lift_in_exp _n _m (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_exp_int : STLCexp_database.

  Lemma term_lift_in_exp_bop :
    forall (_n : nat) (_m : nat) (op : binop) (e1 : exp) (e2 : exp),
      term_lift_in_exp _n _m (bop op e1 e2) =
        bop op (term_lift_in_exp _n _m e1) (term_lift_in_exp _n _m e2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_exp_bop : STLCexp_database.

  Lemma term_lift_in_exp_texp :
    forall (_n : nat) (_m : nat) (t : term),
      term_lift_in_exp _n _m (texp t) =
        texp (term_lift_in_term _n _m t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_exp_texp : STLCexp_database.


  (** *** De Bruijn substitution function *)

  Fixpoint term_subst_in_term (_a : term) (_n : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => var (x - 1)
            (* case _n = x *)
          | inleft (right _) => term_lift_in_term _n 0 _a
            (* case x < _n *)
          | inright _ => var x
        end
      | app t1 t2 =>
        app (term_subst_in_term _a _n t1) (term_subst_in_term _a _n t2)
      | lam t =>
        lam (term_subst_in_term _a (_n + 1) t)
      | eterm e =>
        eterm (term_subst_in_exp _a _n e)
    end

  with term_subst_in_exp (_a : term) (_n : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | int n =>
        int n
      | bop op e1 e2 =>
        bop op (term_subst_in_exp _a _n e1) (term_subst_in_exp _a _n e2)
      | texp t =>
        texp (term_subst_in_term _a _n t)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma term_subst_in_term_var :
    forall (_a : term) (_n : nat) (x : nat),
      term_subst_in_term _a _n (var x) =
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => var (x - 1)
            (* case _n = x *)
          | inleft (right _) => term_lift_in_term _n 0 _a
            (* case x < _n *)
          | inright _ => var x
        end
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_var : STLCexp_database.

  Lemma term_subst_in_term_app :
    forall (_a : term) (_n : nat) (t1 : term) (t2 : term),
      term_subst_in_term _a _n (app t1 t2) =
        app (term_subst_in_term _a _n t1) (term_subst_in_term _a _n t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_app : STLCexp_database.

  Lemma term_subst_in_term_lam :
    forall (_a : term) (_n : nat) (t : term),
      term_subst_in_term _a _n (lam t) =
        lam (term_subst_in_term _a (_n + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_lam : STLCexp_database.

  Lemma term_subst_in_term_eterm :
    forall (_a : term) (_n : nat) (e : exp),
      term_subst_in_term _a _n (eterm e) =
        eterm (term_subst_in_exp _a _n e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_eterm : STLCexp_database.

  (** Equations for De Bruijn substitution function *)

  Lemma term_subst_in_exp_int :
    forall (_a : term) (_n : nat) (n : nat),
      term_subst_in_exp _a _n (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_exp_int : STLCexp_database.

  Lemma term_subst_in_exp_bop :
    forall (_a : term) (_n : nat) (op : binop) (e1 : exp) (e2 : exp),
      term_subst_in_exp _a _n (bop op e1 e2) =
        bop op (term_subst_in_exp _a _n e1) (term_subst_in_exp _a _n e2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_exp_bop : STLCexp_database.

  Lemma term_subst_in_exp_texp :
    forall (_a : term) (_n : nat) (t : term),
      term_subst_in_exp _a _n (texp t) =
        texp (term_subst_in_term _a _n t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_exp_texp : STLCexp_database.

  Module SizedList.
    Set Implicit Arguments.

    Section Definitions.
      Variable A : Type.

      Inductive sized_list : nat -> Type :=
      | snil : sized_list 0
      | scons : A -> forall n : nat, sized_list n -> sized_list (S n).
      
      Implicit Arguments scons [n].
    
      Fixpoint app (n1 : nat) (l1 : sized_list n1) (n2 : nat) (l2 : sized_list n2) : sized_list (n1 + n2) :=
        match l1 in sized_list n1 return sized_list (n1 + n2) with
          | snil => l2
          | scons x _ l1' => scons x (app l1' l2)
        end.
      
      Variable eq : forall x y : A, { x = y } + { x <> y }.
      
      Fixpoint index_of (x : A) (n : nat) (l : sized_list n) : nat :=
        match l with
          | snil => 0
          | scons y _ l' => if eq x y then 0 else S (index_of x l')
        end.
      
      Fixpoint build_permut (n : nat) (l : sized_list n) (n' : nat) (l' : sized_list n') : list nat :=
        match l' with
          | snil => nil
          | scons x _ l'' => cons (index_of x l) (build_permut l l'')
        end.
    
    End Definitions.
  End SizedList.

  Require Import String.
  Local Open Scope string_scope.

  Definition _name_list := SizedList.sized_list string.
  Definition _xcons := @SizedList.scons string.
  Definition _xnil := @SizedList.snil string.
  Definition _index_of := SizedList.index_of string_dec.
  Definition _concat := @SizedList.app string.
  Definition _build_permut := SizedList.build_permut string_dec.


  (** *** Named syntax *)

  Inductive _binop : Type :=
  | _plus 
  | _mult 
  | _db_binop (_arg : binop)
  .

  Hint Constructors _binop : STLCexp_database.

  Inductive _term : Type :=
  | _var (x : string)
  | _app (t1 : _term) (t2 : _term)
  | _lam (xl : _name_list 1) (t : _term)
  | _eterm (e : _exp)
  | _db_term (_xn_term : nat) (_xl_term : _name_list _xn_term) (_arg : term)

  with _exp : Type :=
  | _int (n : nat)
  | _bop (op : _binop) (e1 : _exp) (e2 : _exp)
  | _texp (t : _term)
  | _db_exp (_xn_term : nat) (_xl_term : _name_list _xn_term) (_arg : exp)
  .

  Hint Constructors _term _exp : STLCexp_database.



  (** *** Free variable index permutations *)

  Fixpoint term_fv_permut_in_term (_k : nat) (_l_term : list nat) (_m : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_term) (x - _m)
          then var (x + _k)
          else var (_m + List.nth (x - _m) _l_term 0)
        else var x
      | app t1 t2 =>
        app (term_fv_permut_in_term _k _l_term _m t1) (term_fv_permut_in_term _k _l_term _m t2)
      | lam t =>
        lam (term_fv_permut_in_term _k _l_term (_m + 1) t)
      | eterm e =>
        eterm (term_fv_permut_in_exp _k _l_term _m e)
    end

  with term_fv_permut_in_exp (_k : nat) (_l_exp : list nat) (_m : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | int n =>
        int n
      | bop op e1 e2 =>
        bop op (term_fv_permut_in_exp _k _l_exp _m e1) (term_fv_permut_in_exp _k _l_exp _m e2)
      | texp t =>
        texp (term_fv_permut_in_term _k _l_exp _m t)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma term_fv_permut_in_term_var :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (x : nat),
      term_fv_permut_in_term _k _l_term _m (var x) =
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_term) (x - _m)
          then var (x + _k)
          else var (_m + List.nth (x - _m) _l_term 0)
        else var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_var : STLCexp_database.

  Lemma term_fv_permut_in_term_app :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t1 : term) (t2 : term),
      term_fv_permut_in_term _k _l_term _m (app t1 t2) =
        app (term_fv_permut_in_term _k _l_term _m t1) (term_fv_permut_in_term _k _l_term _m t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_app : STLCexp_database.

  Lemma term_fv_permut_in_term_lam :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t : term),
      term_fv_permut_in_term _k _l_term _m (lam t) =
        lam (term_fv_permut_in_term _k _l_term (_m + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_lam : STLCexp_database.

  Lemma term_fv_permut_in_term_eterm :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (e : exp),
      term_fv_permut_in_term _k _l_term _m (eterm e) =
        eterm (term_fv_permut_in_exp _k _l_term _m e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_eterm : STLCexp_database.

  (** Equations for Free variable index permutations *)

  Lemma term_fv_permut_in_exp_int :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (n : nat),
      term_fv_permut_in_exp _k _l_exp _m (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_exp_int : STLCexp_database.

  Lemma term_fv_permut_in_exp_bop :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (op : binop) (e1 : exp) (e2 : exp),
      term_fv_permut_in_exp _k _l_exp _m (bop op e1 e2) =
        bop op (term_fv_permut_in_exp _k _l_exp _m e1) (term_fv_permut_in_exp _k _l_exp _m e2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_exp_bop : STLCexp_database.

  Lemma term_fv_permut_in_exp_texp :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (t : term),
      term_fv_permut_in_exp _k _l_exp _m (texp t) =
        texp (term_fv_permut_in_term _k _l_exp _m t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_exp_texp : STLCexp_database.


  (** *** Named to De Bruijn translation function *)

  Fixpoint named_to_db_binop  (_arg : _binop) { struct _arg } : binop :=
    match _arg with
      | _plus  =>
        plus
      | _mult  =>
        mult
      | _db_binop _arg =>
        _arg
    end
  .

  (** Equations for Named to De Bruijn translation function *)


  Fixpoint named_to_db_term (_n_term : nat) (_l_term : _name_list _n_term) (_arg : _term) { struct _arg } : term :=
    match _arg with
      | _var x =>
        var (_index_of x _n_term _l_term)
      | _app t1 t2 =>
        app (named_to_db_term _n_term _l_term t1) (named_to_db_term _n_term _l_term t2)
      | _lam xl t =>
        lam (named_to_db_term (1 + _n_term) (_concat 1 xl _n_term _l_term) t)
      | _eterm e =>
        eterm (named_to_db_exp _n_term _l_term e)
      | _db_term _xn_term _xl_term _arg =>
        (term_fv_permut_in_term (_n_term - _xn_term) (_build_permut _n_term _l_term _xn_term _xl_term) 0 _arg)
    end

  with named_to_db_exp (_n_term : nat) (_l_term : _name_list _n_term) (_arg : _exp) { struct _arg } : exp :=
    match _arg with
      | _int n =>
        int n
      | _bop op e1 e2 =>
        bop (named_to_db_binop  op) (named_to_db_exp _n_term _l_term e1) (named_to_db_exp _n_term _l_term e2)
      | _texp t =>
        texp (named_to_db_term _n_term _l_term t)
      | _db_exp _xn_term _xl_term _arg =>
        (term_fv_permut_in_exp (_n_term - _xn_term) (_build_permut _n_term _l_term _xn_term _xl_term) 0 _arg)
    end
  .

  (** Equations for Named to De Bruijn translation function *)


  (** Equations for Named to De Bruijn translation function *)





  (** * Primary lifting and substitution properties *)

  Lemma term_lift_in_term_var_dec :
    forall _n _m _p : nat,
    { prod (_m <= _p) (term_lift_in_term _n _m (var _p) = var (_p + _n)) } +
    { prod (_p < _m) (term_lift_in_term _n _m (var _p) = var _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _term_lift_in_term_var_dec_tac n m p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (term_lift_in_term_var_dec n m p) as
              [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Ltac lift_index_dec_tac :=
    match goal with
      | [ |- context [ term_lift_in_term ?n ?m (var ?p) ] ] =>
        _term_lift_in_term_var_dec_tac n m p

      | [ H : context [ term_lift_in_term ?n ?m (var ?p) ] |- _ ] =>
        _term_lift_in_term_var_dec_tac n m p

    end.

  Lemma term_subst_in_term_var_dec :
    forall (_a : term) (_n _p : nat),
    { prod (_n < _p) (term_subst_in_term _a _n (var _p) = var (_p - 1)) } +
    { prod (_n = _p) (term_subst_in_term _a _n (var _p) = term_lift_in_term _n 0 _a) } +
    { prod (_p < _n) (term_subst_in_term _a _n (var _p) = var _p) }.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ];
      subst; simpl; crush_tac.
  Qed.

  Ltac _term_subst_in_term_var_dec_tac a n p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (term_subst_in_term_var_dec a n p) as
              [ [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ]
                | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Ltac subst_index_dec_tac :=
    match goal with
      | [ |- context [ term_subst_in_term ?a ?n (var ?p) ] ] =>
        _term_subst_in_term_var_dec_tac a n p

      | [ H : context [ term_subst_in_term ?a ?n (var ?p) ] |- _ ] =>
        _term_subst_in_term_var_dec_tac a n p

    end.

  Lemma term_lift_in_term_var_le :
    forall _n _m _p : nat,
      _m <= _p -> term_lift_in_term _n _m (var _p) = var (_p + _n).
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_lift_in_term_var_lt :
    forall _n _m _p : nat,
      _p < _m -> term_lift_in_term _n _m (var _p) = var _p.
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Ltac lift_index_tac :=
    match goal with
      | [ |- context [ term_lift_in_term ?n ?m (var ?p) ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var (p + n));
            [ | apply (term_lift_in_term_var_le n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var p);
            [ | apply (term_lift_in_term_var_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ H : context [ term_lift_in_term ?n ?m (var ?p) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var (p + n)) in H;
            [ | apply (term_lift_in_term_var_le n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var p) in H;
            [ | apply (term_lift_in_term_var_lt n m p); cfail ]) ||
          lift_index_dec_tac

    end.

  Lemma term_subst_in_term_var_lt_l :
    forall (_a : term) (_n _p : nat),
      _n < _p -> term_subst_in_term _a _n (var _p) = var (_p - 1).
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma term_subst_in_term_var_eq :
    forall (_a : term) (_n _p : nat),
      _n = _p -> term_subst_in_term _a _n (var _p) = term_lift_in_term _n 0 _a.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma term_subst_in_term_var_lt_r :
    forall (_a : term) (_n _p : nat),
      _p < _n -> term_subst_in_term _a _n (var _p) = var _p.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Ltac subst_index_tac :=
    match goal with
        | [ |- context [ term_subst_in_term ?a ?n (var ?m) ] ] =>
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var (m - 1));
            [ | apply (term_subst_in_term_var_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = term_lift_in_term n 0 a);
            [ | apply (term_subst_in_term_var_eq a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var m);
            [ | apply (term_subst_in_term_var_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ H : context [ term_subst_in_term ?a ?n (var ?m) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var (m - 1)) in H;
            [ | apply (term_subst_in_term_var_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = term_lift_in_term n 0 a) in H;
            [ | apply (term_subst_in_term_var_eq a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var m) in H;
            [ | apply (term_subst_in_term_var_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

    end.

  Ltac index_tac :=
    repeat (progress (lift_index_tac || subst_index_tac)).



  (** * Additional properties *)


  (** ** Lifting main properties *)


  (** *** Lifting with 0 simplification *)

  Lemma term_lift_in_term_0_simpl :
    forall (_arg : term) (_m : nat),
      term_lift_in_term 0 _m _arg = _arg

  with term_lift_in_exp_0_simpl :
    forall (_arg : exp) (_m : nat),
      term_lift_in_exp 0 _m _arg = _arg
  .
  Proof.
    (* case term_lift_in_term_0_simpl *)
    Focus. clear term_lift_in_term_0_simpl.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_lift_in_exp_0_simpl; crush_tac
        ];
      idtac.

    (* case term_lift_in_exp_0_simpl *)
    Focus. clear term_lift_in_exp_0_simpl.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ];
      intro _m; 
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_lift_in_term_0_simpl; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite term_lift_in_term_0_simpl : STLCexp_database.

  Hint Rewrite term_lift_in_exp_0_simpl : STLCexp_database.

  (** *** Lifting with 0 simplification generalized *)

  Lemma term_lift_in_term_0_simpl_gen :
    forall (_arg : term) (_n _m : nat),
      _n = 0 -> term_lift_in_term _n _m _arg = _arg

  with term_lift_in_exp_0_simpl_gen :
    forall (_arg : exp) (_n _m : nat),
      _n = 0 -> term_lift_in_exp _n _m _arg = _arg
  .
  Proof.
    (* case term_lift_in_term_0_simpl_gen *)
    Focus. clear term_lift_in_term_0_simpl_gen.
    intros; subst; crush_tac.

    (* case term_lift_in_exp_0_simpl_gen *)
    Focus. clear term_lift_in_exp_0_simpl_gen.
    intros; subst; crush_tac.
  Qed.


  Ltac lift_0_simpl_tac :=
    repeat
      match goal with
        | [ |- context [ term_lift_in_term ?n ?m ?t ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m t = t);
            [ | apply (term_lift_in_term_0_simpl_gen t n m); cfail ])
        | [ H : context [ term_lift_in_term ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m t = t) in H;
            [ | apply (term_lift_in_term_0_simpl_gen t n m); cfail ])
        | [ |- context [ term_lift_in_exp ?n ?m ?t ] ] =>
          (cutrewrite ->
            (term_lift_in_exp n m t = t);
            [ | apply (term_lift_in_exp_0_simpl_gen t n m); cfail ])
        | [ H : context [ term_lift_in_exp ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_exp n m t = t) in H;
            [ | apply (term_lift_in_exp_0_simpl_gen t n m); cfail ])
      end; crush_tac.

  (** *** Lifting over lifting simplification and commutation *)

  Lemma term_lift_in_term_term_lift_in_term_simpl :
    forall (_arg : term) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      term_lift_in_term _n _m (term_lift_in_term _n' _m' _arg) =
      term_lift_in_term (_n' + _n) _m' _arg

  with term_lift_in_exp_term_lift_in_exp_simpl :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      term_lift_in_exp _n _m (term_lift_in_exp _n' _m' _arg) =
      term_lift_in_exp (_n' + _n) _m' _arg
  .
  Proof.
    (* case term_lift_in_term_term_lift_in_term_simpl *)
    Focus. clear term_lift_in_term_term_lift_in_term_simpl.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_lift_in_exp_term_lift_in_exp_simpl; crush_tac
        ];
      idtac.

    (* case term_lift_in_exp_term_lift_in_exp_simpl *)
    Focus. clear term_lift_in_exp_term_lift_in_exp_simpl.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_lift_in_term_term_lift_in_term_simpl; crush_tac
        ];
      idtac.
  Qed.


  Lemma term_lift_in_term_term_lift_in_term_commut :
    forall (_arg : term) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      term_lift_in_term _n _m (term_lift_in_term _n' _m' _arg) =
      term_lift_in_term _n' _m' (term_lift_in_term _n (_m - _n') _arg)

  with term_lift_in_exp_term_lift_in_exp_commut :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      term_lift_in_exp _n _m (term_lift_in_exp _n' _m' _arg) =
      term_lift_in_exp _n' _m' (term_lift_in_exp _n (_m - _n') _arg)
  .
  Proof.
    (* case term_lift_in_term_term_lift_in_term_commut *)
    Focus. clear term_lift_in_term_term_lift_in_term_commut.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_lift_in_exp_term_lift_in_exp_commut; crush_tac
        ];
      idtac.

    (* case term_lift_in_exp_term_lift_in_exp_commut *)
    Focus. clear term_lift_in_exp_term_lift_in_exp_commut.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ]; intros;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_lift_in_term_term_lift_in_term_commut; crush_tac
        ];
      idtac.
  Qed.


  Ltac lift_lift_tac :=
    repeat
      match goal with
        | [ |- context [ term_lift_in_term ?n ?m (term_lift_in_term ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term (p + n) q t);
            [ | apply (term_lift_in_term_term_lift_in_term_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term p q (term_lift_in_term n (m - p) t));
            [ | apply (term_lift_in_term_term_lift_in_term_commut t n m p q); cfail ])
        | [ H : context [ term_lift_in_term ?n ?m (term_lift_in_term ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term (p + n) q t) in H;
            [ | apply (term_lift_in_term_term_lift_in_term_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term p q (term_lift_in_term n (m - p) t)) in H;
            [ | apply (term_lift_in_term_term_lift_in_term_commut t n m p q); cfail ])
        | [ |- context [ term_lift_in_exp ?n ?m (term_lift_in_exp ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (term_lift_in_exp n m (term_lift_in_exp p q t) =
             term_lift_in_exp (p + n) q t);
            [ | apply (term_lift_in_exp_term_lift_in_exp_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_exp n m (term_lift_in_exp p q t) =
             term_lift_in_exp p q (term_lift_in_exp n (m - p) t));
            [ | apply (term_lift_in_exp_term_lift_in_exp_commut t n m p q); cfail ])
        | [ H : context [ term_lift_in_exp ?n ?m (term_lift_in_exp ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_exp n m (term_lift_in_exp p q t) =
             term_lift_in_exp (p + n) q t) in H;
            [ | apply (term_lift_in_exp_term_lift_in_exp_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_exp n m (term_lift_in_exp p q t) =
             term_lift_in_exp p q (term_lift_in_exp n (m - p) t)) in H;
            [ | apply (term_lift_in_exp_term_lift_in_exp_commut t n m p q); cfail ])
      end; crush_tac.

  Ltac lift_tac :=
    crush_tac;
    repeat (progress (lift_index_tac || lift_0_simpl_tac || lift_lift_tac)).


  (** ** Substitution main properties *)


  (** *** Interactions between lifting and substitution *)

  Lemma term_subst_in_term_term_lift_in_term_simpl :
    forall (_arg : term) (_arg' : term) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      term_subst_in_term _arg' _p (term_lift_in_term _n _m _arg) =
      term_lift_in_term (_n - 1) _m _arg

  with term_subst_in_exp_term_lift_in_exp_simpl :
    forall (_arg : exp) (_arg' : term) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      term_subst_in_exp _arg' _p (term_lift_in_exp _n _m _arg) =
      term_lift_in_exp (_n - 1) _m _arg
  .
  Proof.
    (* case term_subst_in_term_term_lift_in_term_simpl *)
    Focus. clear term_subst_in_term_term_lift_in_term_simpl.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_subst_in_exp_term_lift_in_exp_simpl; crush_tac
        ];
      idtac.

    (* case term_subst_in_exp_term_lift_in_exp_simpl *)
    Focus. clear term_subst_in_exp_term_lift_in_exp_simpl.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ]; intros;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_subst_in_term_term_lift_in_term_simpl; crush_tac
        ];
      idtac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_0_simpl :
    forall (_arg : term) (_n _m : nat),
      0 < _n ->
      term_subst_in_term (var 0) _m (term_lift_in_term _n (S _m) _arg) =
      term_lift_in_term (_n - 1) (S _m) _arg

  with term_subst_in_exp_term_lift_in_exp_0_simpl :
    forall (_arg : exp) (_n _m : nat),
      0 < _n ->
      term_subst_in_exp (var 0) _m (term_lift_in_exp _n (S _m) _arg) =
      term_lift_in_exp (_n - 1) (S _m) _arg
  .
  Proof.
    (* case term_subst_in_term_term_lift_in_term_0_simpl *)
    Focus. clear term_subst_in_term_term_lift_in_term_0_simpl.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_subst_in_exp_term_lift_in_exp_0_simpl; crush_tac
        ];
      crush_tac.

    (* case term_subst_in_exp_term_lift_in_exp_0_simpl *)
    Focus. clear term_subst_in_exp_term_lift_in_exp_0_simpl.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ]; intros;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_subst_in_term_term_lift_in_term_0_simpl; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_commut :
    forall (_arg : term) (_arg' : term) (_n _m _p : nat),
      _m <= _p ->
      term_lift_in_term _n _m (term_subst_in_term _arg' _p _arg) =
      term_subst_in_term _arg' (_p + _n) (term_lift_in_term _n _m _arg)

  with term_subst_in_exp_term_lift_in_exp_commut :
    forall (_arg : exp) (_arg' : term) (_n _m _p : nat),
      _m <= _p ->
      term_lift_in_exp _n _m (term_subst_in_exp _arg' _p _arg) =
      term_subst_in_exp _arg' (_p + _n) (term_lift_in_exp _n _m _arg)
  .
  Proof.
    (* case term_subst_in_term_term_lift_in_term_commut *)
    Focus. clear term_subst_in_term_term_lift_in_term_commut.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_subst_in_exp_term_lift_in_exp_commut; crush_tac
        ];
      lift_tac; crush_tac.

    (* case term_subst_in_exp_term_lift_in_exp_commut *)
    Focus. clear term_subst_in_exp_term_lift_in_exp_commut.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ]; intros;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_subst_in_term_term_lift_in_term_commut; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_distrib :
    forall (_arg : term) (_arg' : term) (_n _m _p : nat),
      _p <= _m ->
      term_lift_in_term _n _m (term_subst_in_term _arg' _p _arg) =
      term_subst_in_term (term_lift_in_term _n (_m - _p) _arg') _p (term_lift_in_term _n (S _m) _arg)

  with term_subst_in_exp_term_lift_in_exp_distrib :
    forall (_arg : exp) (_arg' : term) (_n _m _p : nat),
      _p <= _m ->
      term_lift_in_exp _n _m (term_subst_in_exp _arg' _p _arg) =
      term_subst_in_exp (term_lift_in_term _n (_m - _p) _arg') _p (term_lift_in_exp _n (S _m) _arg)
  .
  Proof.
    (* case term_subst_in_term_term_lift_in_term_distrib *)
    Focus. clear term_subst_in_term_term_lift_in_term_distrib.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_subst_in_exp_term_lift_in_exp_distrib; crush_tac
        ];
      lift_tac; crush_tac.

    (* case term_subst_in_exp_term_lift_in_exp_distrib *)
    Focus. clear term_subst_in_exp_term_lift_in_exp_distrib.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ]; intros;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_subst_in_term_term_lift_in_term_distrib; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Ltac subst_lift_tac :=
    repeat
      match goal with
        | [ |- context [ term_subst_in_term ?v ?p (term_lift_in_term ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (term_subst_in_term v p (term_lift_in_term n m t) =
             term_lift_in_term (n - 1) m t);
            [ | apply (term_subst_in_term_term_lift_in_term_simpl t v n m p); cfail ])
        | [ H : context [ term_subst_in_term ?v ?p (term_lift_in_term ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term v p (term_lift_in_term n m t) =
             term_lift_in_term (n - 1) m t) in H;
            [ | apply (term_subst_in_term_term_lift_in_term_simpl t v n m p); cfail ])
        | [ |- context [ term_subst_in_exp ?v ?p (term_lift_in_exp ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (term_subst_in_exp v p (term_lift_in_exp n m t) =
             term_lift_in_exp (n - 1) m t);
            [ | apply (term_subst_in_exp_term_lift_in_exp_simpl t v n m p); cfail ])
        | [ H : context [ term_subst_in_exp ?v ?p (term_lift_in_exp ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_exp v p (term_lift_in_exp n m t) =
             term_lift_in_exp (n - 1) m t) in H;
            [ | apply (term_subst_in_exp_term_lift_in_exp_simpl t v n m p); cfail ])
        | [ |- context [ term_subst_in_term (var 0) ?m (term_lift_in_term ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (term_subst_in_term (var 0) m (term_lift_in_term n (S m) t) =
             term_lift_in_term (n - 1) (S m) t);
            [ | apply (term_subst_in_term_term_lift_in_term_0_simpl t n m); cfail ])
        | [ H : context [ term_subst_in_term (var 0) ?m (term_lift_in_term ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term (var 0) m (term_lift_in_term n (S m) t) =
             term_lift_in_term (n - 1) (S m) t) in H;
            [ | apply (term_subst_in_term_term_lift_in_term_0_simpl t n m); cfail ])
        | [ |- context [ term_subst_in_exp (var 0) ?m (term_lift_in_exp ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (term_subst_in_exp (var 0) m (term_lift_in_exp n (S m) t) =
             term_lift_in_exp (n - 1) (S m) t);
            [ | apply (term_subst_in_exp_term_lift_in_exp_0_simpl t n m); cfail ])
        | [ H : context [ term_subst_in_exp (var 0) ?m (term_lift_in_exp ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_exp (var 0) m (term_lift_in_exp n (S m) t) =
             term_lift_in_exp (n - 1) (S m) t) in H;
            [ | apply (term_subst_in_exp_term_lift_in_exp_0_simpl t n m); cfail ])
        | [ |- context [ term_lift_in_term ?n ?m (term_subst_in_term ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term v (p + n) (term_lift_in_term n m t));
            [ cfail | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n (m - p) v) p (term_lift_in_term n (S m) t));
            [ cfail | apply (term_subst_in_term_term_lift_in_term_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term v (p + n) (term_lift_in_term n m t));
            [ | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ])
        | [ H : context [ term_lift_in_term ?n ?m (term_subst_in_term ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term v (p + n) (term_lift_in_term n m t)) in H;
            [ cfail | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n (m - p) v) p (term_lift_in_term n (S m) t)) in H;
            [ cfail | apply (term_subst_in_term_term_lift_in_term_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term v (p + n) (term_lift_in_term n m t)) in H;
            [ | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ])
        | [ |- context [ term_lift_in_exp ?n ?m (term_subst_in_exp ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (term_lift_in_exp n m (term_subst_in_exp v p t) =
             term_subst_in_exp v (p + n) (term_lift_in_exp n m t));
            [ cfail | apply (term_subst_in_exp_term_lift_in_exp_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_exp n m (term_subst_in_exp v p t) =
             term_subst_in_exp (term_lift_in_term n (m - p) v) p (term_lift_in_exp n (S m) t));
            [ cfail | apply (term_subst_in_exp_term_lift_in_exp_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_exp n m (term_subst_in_exp v p t) =
             term_subst_in_exp v (p + n) (term_lift_in_exp n m t));
            [ | apply (term_subst_in_exp_term_lift_in_exp_commut t v n m p); cfail ])
        | [ H : context [ term_lift_in_exp ?n ?m (term_subst_in_exp ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_exp n m (term_subst_in_exp v p t) =
             term_subst_in_exp v (p + n) (term_lift_in_exp n m t)) in H;
            [ cfail | apply (term_subst_in_exp_term_lift_in_exp_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_exp n m (term_subst_in_exp v p t) =
             term_subst_in_exp (term_lift_in_term n (m - p) v) p (term_lift_in_exp n (S m) t)) in H;
            [ cfail | apply (term_subst_in_exp_term_lift_in_exp_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_exp n m (term_subst_in_exp v p t) =
             term_subst_in_exp v (p + n) (term_lift_in_exp n m t)) in H;
            [ | apply (term_subst_in_exp_term_lift_in_exp_commut t v n m p); cfail ])
      end; crush_tac.

  (** *** Substitution lemma *)

  Lemma term_subst_in_term_term_subst_in_term_distrib :
    forall (_arg : term) (_arg' _arg'' : term) (_n _m : nat),
      _m <= _n ->
      term_subst_in_term _arg' _n (term_subst_in_term _arg'' _m _arg) =
      term_subst_in_term (term_subst_in_term _arg' (_n - _m) _arg'') _m (term_subst_in_term _arg' (S _n) _arg)

  with term_subst_in_exp_term_subst_in_exp_distrib :
    forall (_arg : exp) (_arg' _arg'' : term) (_n _m : nat),
      _m <= _n ->
      term_subst_in_exp _arg' _n (term_subst_in_exp _arg'' _m _arg) =
      term_subst_in_exp (term_subst_in_term _arg' (_n - _m) _arg'') _m (term_subst_in_exp _arg' (S _n) _arg)
  .
  Proof.
    (* case term_subst_in_term_term_subst_in_term_distrib *)
    Focus. clear term_subst_in_term_term_subst_in_term_distrib.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_subst_in_exp_term_subst_in_exp_distrib; crush_tac
        ];
      subst_lift_tac; crush_tac.

    (* case term_subst_in_exp_term_subst_in_exp_distrib *)
    Focus. clear term_subst_in_exp_term_subst_in_exp_distrib.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ]; intros;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_subst_in_term_term_subst_in_term_distrib; crush_tac
        ];
      subst_lift_tac; crush_tac.
  Qed.


  Ltac subst_subst_tac :=
    repeat
      match goal with
        | [ |- context [ term_subst_in_term ?b ?n (term_subst_in_term ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (term_subst_in_term b n (term_subst_in_term c m a) =
             term_subst_in_term (term_subst_in_term b (n - m) c) m (term_subst_in_term b (S n) a));
            [ | apply (term_subst_in_term_term_subst_in_term_distrib a b c n m); cfail ])
        | [ H : context [ term_subst_in_term ?b ?n (term_subst_in_term ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term b n (term_subst_in_term c m a) =
             term_subst_in_term (term_subst_in_term b (n - m) c) m (term_subst_in_term b (S n) a)) in H;
            [ | apply (term_subst_in_term_term_subst_in_term_distrib a b c n m); cfail ])
        | [ |- context [ term_subst_in_exp ?b ?n (term_subst_in_exp ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (term_subst_in_exp b n (term_subst_in_exp c m a) =
             term_subst_in_exp (term_subst_in_term b (n - m) c) m (term_subst_in_exp b (S n) a));
            [ | apply (term_subst_in_exp_term_subst_in_exp_distrib a b c n m); cfail ])
        | [ H : context [ term_subst_in_exp ?b ?n (term_subst_in_exp ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_exp b n (term_subst_in_exp c m a) =
             term_subst_in_exp (term_subst_in_term b (n - m) c) m (term_subst_in_exp b (S n) a)) in H;
            [ | apply (term_subst_in_exp_term_subst_in_exp_distrib a b c n m); cfail ])
      end; crush_tac.

  Ltac subst_tac :=
    crush_tac;
    repeat (progress (subst_index_tac || subst_lift_tac || subst_subst_tac)).


  (** ** Free variables permutation properties *)

  Lemma term_fv_permut_in_term_var_dec :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
    { prod (prod (_m <= _p) ((_p - _m) < List.length _l)) (term_fv_permut_in_term _k _l _m (var _p) = var (_m + List.nth (_p - _m) _l 0)) } +
    { prod (prod (_m <= _p) (List.length _l <= (_p - _m))) (term_fv_permut_in_term _k _l _m (var _p) = var (_p + _k)) } +
    { prod (_p < _m) (term_fv_permut_in_term _k _l _m (var _p) = var _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _term_fv_permut_in_term_var_dec_tac k l m p :=
    let Hcomp := fresh "Hcomp" in
       let Hcomp' := fresh "Hcomp'" in
          let Hfun := fresh "Hfun" in
            destruct (term_fv_permut_in_term_var_dec k l m p) as
              [ [ [ [ Hcomp Hcomp' ] Hfun ] | [ [ Hcomp Hcomp' ] Hfun ] ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.


  Ltac fv_permut_index_dec_tac :=
    match goal with
      | [ |- context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] ] =>
        _term_fv_permut_in_term_var_dec_tac k l m p

      | [ H : context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] |- _ ] =>
        _term_fv_permut_in_term_var_dec_tac k l m p

    end.

  Lemma term_fv_permut_in_term_var_le_le :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> List.length _l <= (_p - _m) -> term_fv_permut_in_term _k _l _m (var _p) = var (_p + _k).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_fv_permut_in_term_var_le_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> (_p - _m) < List.length _l -> term_fv_permut_in_term _k _l _m (var _p) = var (_m + List.nth (_p - _m) _l 0).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_fv_permut_in_term_var_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _p < _m -> term_fv_permut_in_term _k _l _m (var _p) = var _p.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.


  Ltac fv_permut_index_tac :=
    repeat match goal with
      | [ |- context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (p + k));
            [ | apply (term_fv_permut_in_term_var_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (m + List.nth (p - m) l 0));
            [ | apply (term_fv_permut_in_term_var_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var p);
            [ | apply (term_fv_permut_in_term_var_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ H : context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] |- _ ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (p + k)) in H;
            [ | apply (term_fv_permut_in_term_var_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (m + List.nth (p - m) l 0)) in H;
            [ | apply (term_fv_permut_in_term_var_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var p) in H;
            [ | apply (term_fv_permut_in_term_var_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

    end.

  (** *** Identity free variables permutation simplification *)

  Lemma term_fv_permut_in_term_id_simpl :
    forall (_k : nat) (_arg : term) (_m _n : nat),
      term_fv_permut_in_term _k (List.seq 0 _n) _m _arg = term_lift_in_term _k (_m + _n) _arg

  with term_fv_permut_in_exp_id_simpl :
    forall (_k : nat) (_arg : exp) (_m _n : nat),
      term_fv_permut_in_exp _k (List.seq 0 _n) _m _arg = term_lift_in_exp _k (_m + _n) _arg
  .
  Proof.
    (* case term_fv_permut_in_term_id_simpl *)
    Focus. clear term_fv_permut_in_term_id_simpl.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | t IHt | e ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite term_fv_permut_in_exp_id_simpl; crush_tac
        ];
      idtac.

    (* case term_fv_permut_in_exp_id_simpl *)
    Focus. clear term_fv_permut_in_exp_id_simpl.
    induction _arg as [ n | op e1 IHe1 e2 IHe2 | t ];
      intros _m _n;
        [ simpl; crush_tac
        | simpl; simpl; try rewrite IHe1; simpl; try rewrite IHe2; crush_tac
        | simpl; try rewrite term_fv_permut_in_term_id_simpl; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite term_fv_permut_in_term_id_simpl : STLCexp_database.

  Hint Rewrite term_fv_permut_in_exp_id_simpl : STLCexp_database.

  (** *** Identity free variables permutation simplification generalized *)

  Lemma term_fv_permut_in_term_id_simpl_gen :
    forall (_k : nat) (_arg : term) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> term_fv_permut_in_term _k _l _m _arg = term_lift_in_term _k (_m + List.length _l) _arg

  with term_fv_permut_in_exp_id_simpl_gen :
    forall (_k : nat) (_arg : exp) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> term_fv_permut_in_exp _k _l _m _arg = term_lift_in_exp _k (_m + List.length _l) _arg
  .
  Proof.
    (* case term_fv_permut_in_term_id_simpl_gen *)
    Focus. clear term_fv_permut_in_term_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case term_fv_permut_in_exp_id_simpl_gen *)
    Focus. clear term_fv_permut_in_exp_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Ltac fv_permut_id_simpl_tac :=
    repeat
      match goal with
        | [ |- context [ term_fv_permut_in_term ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m t = term_lift_in_term k (m + List.length l) t);
            [ | (apply (term_fv_permut_in_term_id_simpl_gen k t l m 0); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 1); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 2); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 3); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 4); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ term_fv_permut_in_term ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m t = term_lift_in_term k (m + List.length l) t) in H;
            [ | (apply (term_fv_permut_in_term_id_simpl_gen k t l m 0); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 1); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 2); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 3); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 4); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ term_fv_permut_in_exp ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (term_fv_permut_in_exp k l m t = term_lift_in_exp k (m + List.length l) t);
            [ | (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 0); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 1); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 2); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 3); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 4); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ term_fv_permut_in_exp ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (term_fv_permut_in_exp k l m t = term_lift_in_exp k (m + List.length l) t) in H;
            [ | (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 0); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 1); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 2); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 3); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 4); cfail) ||
                (apply (term_fv_permut_in_exp_id_simpl_gen k t l m 5); cfail) ])
      end; crush_tac.

  Ltac fv_permut_tac :=
    crush_tac;
    repeat (progress (fv_permut_index_tac || fv_permut_id_simpl_tac)).




  (** * Main dbgen tactic *)

  Ltac dbgen_tac :=
    crush_tac;
    repeat (progress (index_tac || lift_tac || subst_tac || fv_permut_tac)).


End STLCexp.
