module Xlib = struct
	
	(**
	* repeatedly applies a function to a value until fixpoint.
	*
	* @params f v
	* @param f the function to apply.
	* @param v the initial value.
	*
	* @return a value w such that f w = w.
	*)
	let rec fixpoint f v =
		let w = f v in
		if v = w then w
		else fixpoint f w
	
	(**
	*
	*)
	let some_of o =
		match o with
				Some x -> x
			| None -> raise (Invalid_argument "some_of")
	
end
